From b8663e546d2b0ca2ec0f8f408b8e8665e52cb5b4 Mon Sep 17 00:00:00 2001
From: foobar1643 <foobar76239@gmail.com>
Date: Sat, 23 Jan 2021 12:29:39 +0200
Subject: [PATCH] apc.php, fix division by zero fatal error in PHP 8.0

---
 apc.php | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

diff --git a/apc.php b/apc.php
index d1f6029..8c23a5e 100644
--- a/apc.php
+++ b/apc.php
@@ -759,7 +759,9 @@ function block_sort($array1, $array2)
 	$apcversion = phpversion('apcu');
 	$phpversion = phpversion();
 	$number_vars = $cache['num_entries'];
-    $size_vars = bsize($cache['mem_size']);
+	$size_vars = bsize($cache['mem_size']);
+	$num_hits_and_misses = $cache['num_hits'] + $cache['num_misses'];
+	$num_hits_and_misses = 0 >= $num_hits_and_misses ? 1 : $num_hits_and_misses;
 	$i=0;
 	echo <<< EOB
 		<div class="info div1"><h2>General Cache Information</h2>
@@ -836,11 +838,11 @@ function block_sort($array1, $array2)
 			: "",
 		'<tr>',
 		'<td class=td-0><span class="green box">&nbsp;</span>Free: ',bsize($mem_avail).sprintf(" (%.1f%%)",$mem_avail*100/$mem_size),"</td>\n",
-		'<td class=td-1><span class="green box">&nbsp;</span>Hits: ',$cache['num_hits'].@sprintf(" (%.1f%%)",$cache['num_hits']*100/($cache['num_hits']+$cache['num_misses'])),"</td>\n",
+		'<td class=td-1><span class="green box">&nbsp;</span>Hits: ',$cache['num_hits'].@sprintf(" (%.1f%%)",$cache['num_hits']*100/$num_hits_and_misses),"</td>\n",
 		'</tr>',
 		'<tr>',
 		'<td class=td-0><span class="red box">&nbsp;</span>Used: ',bsize($mem_used).sprintf(" (%.1f%%)",$mem_used *100/$mem_size),"</td>\n",
-		'<td class=td-1><span class="red box">&nbsp;</span>Misses: ',$cache['num_misses'].@sprintf(" (%.1f%%)",$cache['num_misses']*100/($cache['num_hits']+$cache['num_misses'])),"</td>\n";
+		'<td class=td-1><span class="red box">&nbsp;</span>Misses: ',$cache['num_misses'].@sprintf(" (%.1f%%)",$cache['num_misses']*100/$num_hits_and_misses),"</td>\n";
 	echo <<< EOB
 		</tr>
 		</tbody></table>
